package com.liang.dao;

import com.liang.entity.BaseSchool;
import com.liang.entity.BaseTitle;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;
import java.util.Map;

/**
 * (BaseTitle)表数据库访问层
 *
 * @author makejava
 * @since 2023-03-03 21:59:50
 */
public interface BaseTitleDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    BaseTitle queryById(Object id);

    /**
     * 查询指定行数据
     *
     * @param baseTitle 查询条件
     * @param pageable  分页对象
     * @return 对象列表
     */
    List<BaseTitle> queryAllByLimit(BaseTitle baseTitle, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param baseTitle 查询条件
     * @return 总行数
     */
    long count(BaseTitle baseTitle);

    /**
     * 新增数据
     *
     * @param baseTitle 实例对象
     * @return 影响行数
     */
    int insert(BaseTitle baseTitle);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<BaseTitle> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<BaseTitle> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<BaseTitle> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<BaseTitle> entities);

    /**
     * 修改数据
     *
     * @param baseTitle 实例对象
     * @return 影响行数
     */
    int update(BaseTitle baseTitle);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Object id);

    /**
     * 获取所有数据
     *
     * @return
     */
    List<BaseTitle> queryAll();

    /**
     * 获取职称列表
     *
     * @return
     */
    List<Map<String, String>> getTitleList();
}

